#!/bin/bash

### BEGIN INIT INFO
# Provides:          havp
# Required-Start:    $local_fs $remote_fs $network $named $time
# Should-Start:      
# Required-Stop:     $local_fs $remote_fs $network
# Should-Stop:       
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: starts HAVP the High Availability Antivirus Proxy
### END INIT INFO

NAME="HAVP"
FOO_BIN=/usr/sbin/havp
FOO_CONFIG=/etc/havp/havp.config
FOO_LOG=/var/log/havp/havp.log

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
test -x $FOO_BIN || { echo "$FOO_BIN not installed";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }

# Check for existence of needed config file and read it
test -r $FOO_CONFIG || { echo "$FOO_CONFIG not existing";
    if [ "$1" = "stop" ]; then exit 0;
    else exit 6; fi; }


source /etc/rc.status

# Reset status of this service
rc_reset


case "$1" in
    start)
        echo -n "Starting $NAME "
        startproc -l $FOO_LOG $FOO_BIN
        rc_status -v
        ;;
    stop)
        echo -n "Shutting down $NAME "
        ## Stop daemon with killproc(8) and if this fails
        ## killproc sets the return value according to LSB.
    
        # stopping the daemon was often not successfull.
        # killing it twice did always work so far
        /sbin/killproc -TERM $FOO_BIN
        sleep 1
        /sbin/killproc $FOO_BIN
    
        # Remember status and be verbose
        rc_status -v
        ;;
    try-restart|condrestart)
        ## Do a restart only if the service was active before.
        ## Note: try-restart is now part of LSB (as of 1.9).
        ## RH has a similar command named condrestart.
        if test "$1" = "condrestart"; then
            echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
        fi
        $0 status
        if test $? = 0; then
            $0 restart
        else
            rc_reset    # Not running is not a failure.
        fi
        # Remember status and be quiet
        rc_status
        ;;
    restart)
        ## Stop the service and regardless of whether it was
        ## running or not, start it again.
        $0 stop
        $0 start
    
        # Remember status and be quiet
        rc_status
        ;;
    force-reload)
        echo -n "Reload service $NAME "
        #$0 try-restart
        killproc -HUP $FOO_BIN
        rc_status
        ;;
    reload)
        ## Like force-reload, but if daemon does not support
        ## signaling, do nothing (!)
        echo -n "Reload service $NAME "
        #rc_failed 3
        killproc -HUP $FOO_BIN
        rc_status -v
        ;;
    status)
        echo -n "Checking for service $NAME "
        ## Check status with checkproc(8), if process is running
        ## checkproc will return with exit status 0.
    
        # Return value is slightly different for the status command:
        # 0 - service up and running
        # 1 - service dead, but /var/run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
        
        # NOTE: checkproc returns LSB compliant status values.
        /sbin/checkproc $FOO_BIN
        # NOTE: rc_status knows that we called this init script with
        # "status" option and adapts its messages accordingly.
        rc_status -v
        ;;
    *)
        echo "Usage: $0 {start|status|try-restart|restart|force-reload|reload}"
        exit 1
        ;;
esac
rc_exit
